// AutoBrick.h:   CAutoBrick
//
///////////////////////////////////////////////////////////////////////

#include "BigBrick.h"
#include <list>

using namespace std;


//  -     
struct action
{
	int	side;
	bool direct;
};


//    
class CAutoBrick
{
private:
	CBigBrick*	br;					//    
	int			state;              //  
public:
	bool		finish;             //   
	int			automata;           //   
	long		counter;			//   

public:
	CAutoBrick();                   // 
	CAutoBrick(CBigBrick*);
	virtual ~CAutoBrick(void);      // 

	void Reset();                   //  
	list <action> NextStep();       //  

private:
	//     
	list <int> x1();
	list <int> x2();
	list <int> x3();
	list <int> x4();
	list <int> x5();
	list <int> x6();
	list <int> x7();

	//   
	list <action> z1();
	list <action> z2();
	list <action> z3();
	list <action> z4();
	list <action> z5();
	list <action> z6();
	list <action> z7();
	list <action> z8();
	list <action> z9();
	list <action> z10();
	list <action> z11();
	list <action> z12();
	list <action> z13();
	list <action> z14();
	list <action> z15();
	list <action> z16();
	list <action> z17();
	list <action> z18();
	list <action> z19();
	list <action> z20();
	list <action> z21();
	list <action> z22();
	list <action> z23();
	list <action> z24();
	list <action> z25();

	list <action> z(int);

	//  
	void AddAction(list <action> *, int, bool);
	bool IsIn(int, list <int>);
	bool IsEqual(int, int, int, int, int, int);
};