// BigBrick.cpp:   CBigBrick
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BigBrick.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CBigBrick::CBigBrick()
{
}

CBigBrick::~CBigBrick()
{
}

void CBigBrick::SetX(float x)
/*
	 x - 
*/
{
	nX = x;
}

void CBigBrick::SetY(float y)
/*
	 y - 
*/
{
	nY = y;
}

void CBigBrick::SetZ(float z)
/*
	 z - 
*/
{
	nZ = z;
}


void CBigBrick::SetSize(float size)
/*
	   
*/
{
	nSize = size;
}

void CBigBrick::SetDelta(float d)
{
	nDelta = d;
}

float CBigBrick::GetX()
/*
	 x - 
*/
{
	return nX;
}

float CBigBrick::GetY()
/*
	 y - 
*/
{
	return nY;
}

float CBigBrick::GetZ()
/*
	 z - 
*/
{
	return nZ;
}


float CBigBrick::GetSize()
/*
     
*/
{
	return nSize;
}

float CBigBrick::GetDelta()
{
	return nDelta;
}




void CBigBrick::Init()
/*
	  
*/
{
	for(int i = 0; i < 3; i++)
	{	
		for(int j = 0; j < 3; j++)
		{
			for(int k = 0; k < 3; k++)
			{
				bricks[i][j][k].SetSize(nSize);
				bricks[i][j][k].SetX(i);
				bricks[i][j][k].SetY(j);
				bricks[i][j][k].SetZ(k);
				bricks[i][j][k].SetColor();
				bricks[i][j][k].Refresh();
			}
		}
	}
}


void CBigBrick::Draw()
/*
    
*/
{
	for(int i = 0; i <3; i++)
	{	
		for(int j = 0; j < 3; j++)
		{
			for(int k = 0; k < 3; k++)
			{
				bricks[i][j][k].Draw();				
			}
		}
	}	
}

int CBigBrick::GetColor(int x, int y, int z, int side)
/*
	     color  
	  side   (x,y,z)
*/
{
	return bricks[x][y][z].GetColor(side);
}

void CBigBrick::SetColor(int x, int y, int z, int side, int col)
{
	bricks[x][y][z].SetColor(side, col);
}

int CBigBrick::GetColor(int side, int num)
/*
          num   side
*/
{
	int t_x;
	int t_y;
	int tx;
	int ty;
	int tz;

	t_x = (num - 1) - 3 * ((num - 1) / 3);
	t_y = 2 - (num - 1) / 3;

	switch(side - 1)
	{
		case 0:
			tx = t_x;
			ty = 0;
			tz = t_y;
			break;
		case 1:
			tx = t_x;
			ty = t_y;
			tz = 2;
			break;
		case 2:
			tx = 2;
			ty = t_y;
			tz = 2 - t_x;
			break;
		case 3:
			tx = 2 - t_x;
			ty = t_y;
			tz = 0;			
			break;
		case 4:
			tx = 0;
			ty = t_y;
			tz = t_x;
			break;
		case 5:
			tx = t_x;
			ty = 2;
			tz = 2 - t_y;
			break;
	}

	return (bricks[tx][ty][tz].GetColor(side - 1) + 1);
}


// 
void CBigBrick::Refresh()
/*
	   bricks
*/
{
	int x;
	int y;
	int z;
	CSmallBrick tempBr[3][3][3];	

	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			for(int k = 0; k < 3; k++)
			{
				x = bricks[i][j][k].GetX();
				y = bricks[i][j][k].GetY();
				z = bricks[i][j][k].GetZ();
				tempBr[x][y][z] = bricks[i][j][k];
			}
		}
	}

	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			for(int k = 0; k < 3; k++)
			{
				bricks[i][j][k] = tempBr[i][j][k];
			}
		}
	}
}

void CBigBrick::RotateXNeg(int side)
/*
	    y    
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[side][i][j].RotateXNeg();
		}
	}
	Refresh();
}


void CBigBrick::RotateXPos(int side)
/*
	    y    	
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[side][i][j].RotateXPos();
		}
	}
	Refresh();
}

void CBigBrick::RotateYNeg(int side)
/*
	    y    
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[i][side][j].RotateYNeg();
		}
	}
	Refresh();
}


void CBigBrick::RotateYPos(int side)
/*
	    y    	
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[i][side][j].RotateYPos();
		}
	}
	Refresh();
}

void CBigBrick::RotateZNeg(int side)
/*
	    z   
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[j][i][side].RotateZNeg();
		}
	}
	Refresh();
}


void CBigBrick::RotateZPos(int side)
/*
	    z    	
*/
{
	for(int i = 0; i < 3; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			bricks[j][i][side].RotateZPos();
		}
	}
	Refresh();
}

void CBigBrick::Rotate(int side, bool dir)
/*
	      side.
	 dir,    ,    
	 .       , 
	   
*/
{
	switch(side - 1)
	{
	case 0:
		{
			if (!dir) RotateYPos(0);
			else RotateYNeg(0);
			break;
		}
	case 1:
		{
			if (!dir) RotateZPos(2);
			else RotateZNeg(2);
			break;
		}
	case 2:
		{
			if (dir) RotateXPos(2);
			else RotateXNeg(2);
			break;
		}
	case 3:
		{
			if (dir) RotateZPos(0);
			else RotateZNeg(0);
			break;
		}
	case 4:
		{
			if (!dir) RotateXPos(0);
			else RotateXNeg(0);
			break;
		}
	case 5:
		{
			if (dir) RotateYPos(2);
			else RotateYNeg(2);
			break;
		}
	}
}
