// SmallBrick.cpp:   CSmallBrick
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmallBrick.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CSmallBrick::CSmallBrick()
{
	x = 0;
	y = 0;
	z = 0;
	nSize = 0;
	//  
	
}

CSmallBrick::~CSmallBrick()
{
}

void CSmallBrick::SetX(int tx)
/*
	 x - 
*/
{
	x = tx;
}

void CSmallBrick::SetY(int ty)
/*
	 y - 
*/
{
	y = ty;
}

void CSmallBrick::SetZ(int tz)
/*
	 z - 
*/
{
	z = tz;
}


void CSmallBrick::SetSize(float size)
/*
	   
*/
{
	nSize = size;
}

void CSmallBrick::SetDelta(float d)
{
	nDelta = d;
}

void CSmallBrick::SetColor()
{
	for(int i = 0; i < 6; i++)
	{
		nColor[i].SetNum(i);
	}
}

void CSmallBrick::SetColor(int side, int color)
{
	nColor[side].SetNum(color);
}


int CSmallBrick::GetX()
/*
	 x - 
*/
{
	return x;
}

int CSmallBrick::GetY()
/*
	 y - 
*/
{
	return y;
}

int CSmallBrick::GetZ()
/*
	 z - 
*/
{
	return z;
}


float CSmallBrick::GetSize()
/*
     
*/
{
	return nSize;
}

float CSmallBrick::GetDelta()
{
	return nDelta;
}

int CSmallBrick::GetColor(int side)
/*
	      side
*/
{
	return nColor[side].GetNum();
}


void CSmallBrick::Refresh()
{
	nX = (x-1.5f) * nSize;
	nY = (y-1.5f) * nSize;
	nZ = (z-1.5f) * nSize;	
}

void CSmallBrick::Draw()
/*
	  
*/
{
	

	
	//  
	glColor3f(nColor[1].red, nColor[1].green, nColor[1].blue);
	glBegin(GL_QUADS);
                glVertex3f(nX, nY, nZ);  
				glVertex3f(nX, nY + nSize, nZ);  
				glVertex3f(nX + nSize, nY + nSize, nZ);  
				glVertex3f(nX + nSize, nY, nZ);                  
    glEnd();
	
	//  
	glColor3f(nColor[4].red, nColor[4].green, nColor[4].blue);      
	glBegin(GL_QUADS);
                glVertex3f(nX, nY, nZ); 
				glVertex3f(nX, nY, nZ - nSize); 
				glVertex3f(nX, nY + nSize, nZ - nSize);  
				glVertex3f(nX, nY + nSize, nZ);                  
    glEnd();

	//  
	glColor3f(nColor[2].red, nColor[2].green, nColor[2].blue);     
	glBegin(GL_QUADS);
                glVertex3f(nX + nSize, nY, nZ);  
				glVertex3f(nX + nSize, nY, nZ - nSize);  
				glVertex3f(nX + nSize, nY + nSize, nZ - nSize);  
				glVertex3f(nX + nSize, nY + nSize, nZ);                 
    glEnd();
	
	//  
	glColor3f(nColor[3].red, nColor[3].green, nColor[3].blue);      
	glBegin(GL_QUADS);
                glVertex3f(nX, nY, nZ - nSize);  
				glVertex3f(nX, nY + nSize, nZ - nSize);  
				glVertex3f(nX + nSize, nY + nSize, nZ - nSize);  
				glVertex3f(nX + nSize, nY, nZ - nSize);                  
    glEnd();
	
	//  
	glColor3f(nColor[5].red, nColor[5].green, nColor[5].blue);      
	glBegin(GL_QUADS);
                glVertex3f(nX, nY + nSize, nZ);						//  
				glVertex3f(nX, nY + nSize, nZ - nSize);  			//  
				glVertex3f(nX + nSize, nY + nSize, nZ - nSize);  	//  
				glVertex3f(nX + nSize, nY + nSize, nZ);  			//                  
    glEnd();

	//  
	glColor3f(nColor[0].red, nColor[0].green, nColor[0].blue);      //  
	glBegin(GL_QUADS);
                glVertex3f(nX, nY, nZ);  							//  
				glVertex3f(nX, nY, nZ - nSize);  					//  
				glVertex3f(nX + nSize, nY, nZ - nSize);  			//  
				glVertex3f(nX + nSize, nY, nZ);  					//                  
    glEnd();
}


// 
void CSmallBrick::RotateNeg(int &t, int&r)
/*
	      
*/
{
	if((t == 0)&&( r== 0)) { t = 2; return;}
	if((t == 1)&&( r== 0)) { t = 2; r = 1; return;}
	if((t == 2)&&( r== 0)) { r = 2; return;}
	if((t == 2)&&( r== 1)) { t = 1; r = 2; return;}
	if((t == 2)&&( r== 2)) { t = 0;  return;}
	if((t == 1)&&( r== 2)) { t = 0; r = 1; return;}
	if((t == 0)&&( r== 2)) { t = 0; r = 0; return;}
	if((t == 0)&&( r== 1)) { t = 1; r = 0; return;}

}

void CSmallBrick::RotatePos(int &t, int&r)
/*
	      
*/
{
	if((t == 0)&&( r== 0)) { r = 2; return;}
	if((t == 1)&&( r== 0)) { t = 0; r = 1; return;}
	if((t == 2)&&( r== 0)) { t = 0; return;}
	if((t == 2)&&( r== 1)) { t = 1; r = 0; return;}
	if((t == 2)&&( r== 2)) { r = 0;  return;}
	if((t == 1)&&( r== 2)) { t = 2; r = 1; return;}
	if((t == 0)&&( r== 2)) { t = 2;  return;}
	if((t == 0)&&( r== 1)) { t = 1; r = 2; return;}

}


void CSmallBrick::RotateXNeg()
/*
	    x   
*/
{
	CCol tCol;
	tCol = nColor[0];
	nColor[0] = nColor[1];
	nColor[1] = nColor[5];
	nColor[5]= nColor[3];
	nColor[3] = tCol;
	RotateNeg(y, z);
	Refresh();
}

void CSmallBrick::RotateXPos()
/*
	    x    
*/
{
	CCol tCol;
	tCol = nColor[0];
	nColor[0] = nColor[3];
	nColor[3] = nColor[5];
	nColor[5]= nColor[1];
	nColor[1] = tCol;
	RotatePos(y, z);
	Refresh();
}

void CSmallBrick::RotateYNeg()
/*
	    y   
*/
{
	CCol tCol;
	tCol = nColor[1];
	nColor[1] = nColor[4];
	nColor[4] = nColor[3];
	nColor[3]= nColor[2];
	nColor[2] = tCol;
	RotateNeg(z, x);
	Refresh();
}

void CSmallBrick::RotateYPos()
/*
	    y    
*/
{
	CCol tCol;
	tCol = nColor[1];
	nColor[1] = nColor[2];
	nColor[2] = nColor[3];
	nColor[3]= nColor[4];
	nColor[4] = tCol;
	RotatePos(z, x);
	Refresh();
}

void CSmallBrick::RotateZNeg()
/*
	    z   
*/
{
	CCol tCol;
	tCol = nColor[0];
	nColor[0] = nColor[2];
	nColor[2] = nColor[5];
	nColor[5]= nColor[4];
	nColor[4] = tCol;
	RotateNeg(y, x);
	Refresh();
}

void CSmallBrick::RotateZPos()
/*
	    z    
*/
{
	CCol tCol;
	tCol = nColor[0];
	nColor[0] = nColor[4];
	nColor[4] = nColor[5];
	nColor[5]= nColor[2];
	nColor[2] = tCol;
	RotatePos(y, x);
	Refresh();
}