// AutoBrick.cpp:   CAutoBrick
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AutoBrick.h"

CAutoBrick::CAutoBrick()
{
}

CAutoBrick::CAutoBrick(CBigBrick* br)
{
	this->br = br;

	state = 0;
	automata = 0;
	finish = false;
	counter = 0;
}

CAutoBrick::~CAutoBrick()
{
}

void CAutoBrick::Reset()
/*
	 
*/
{
	state = 0;
	automata = 0;
	finish = false;
	counter = 0;
}



list <action> CAutoBrick::NextStep()
/*
	       
*/
{
	list <action> act;
	
	switch (automata)
	{
		//  1 -  #1
		case 0:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 25; i++)
					{
						if (IsIn(i, x1()))				//    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}
					break;
				case 1:		case 2:		case 3:		case 4:		case 5:		case 6:
				case 7:		case 8:		case 9:		case 10:	case 11:	case 12:
				case 13:	case 14:	case 15:	case 16:	case 17:	case 18:
				case 19:	case 20:	case 21:	case 22:	case 23:	case 24:
					state = 0;
					break;
				case 25:
					if (IsIn(25, x1())) {               //    25  -  
						state = 26;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 26:
					if (IsIn(25, x1())) {               //    25  -  
						state = 27;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 27:
					if (IsIn(25, x1())) {               //    25  -  
						state = 28;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 28:
					state = 0;
					automata = 1;						//   
					break;
				default:
					break;
			}
			break;
		//  2 -  #2
		case 1:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 25; i++)       
					{
						if (IsIn(i, x2()))              //    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}
					break;
				case 1:		case 2:		case 3:		case 4:		case 5:		case 6:
				case 7:		case 8:		case 9:		case 10:	case 11:	case 12:
				case 13:	case 14:	case 15:	case 16:	case 17:	case 18:
				case 19:	case 20:	case 21:	case 22:	case 23:	case 24:
					state = 0;
					break;
				case 25:
					if (IsIn(25, x2())) {               //    25  -  
						state = 26;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 26:
					if (IsIn(25, x2())) {               //    25  -  
						state = 27;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 27:
					if (IsIn(25, x2())) {               //    25  -  
						state = 28;
						counter += z25().size();
						return z25();
					} else {
						state = 0;
					}
					break;
				case 28:
					state = 0;
					automata = 2;                       //   
					break;
				default:
					break;
			}
			break;
		//  3 -  #3
		case 2:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 8; i++)        
					{
						if (IsIn(i, x3()))              //    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}

					if (IsIn(13, x3()))                 //    13  -  
					{
						state = 9;
						counter += z13().size();
						return z13();
					}
					break;
				case 1:		case 2:		case 3:		case 4:
				case 5:		case 6:		case 7:		case 8:
					state = 0;
					break;
				case 9:
					if (IsIn(13, x3()))	                //    13  -  
					{
						state = 10;
						counter += z13().size();
						return z13();
					}

					for (int i = 1; i <= 8; i++)        
					{
						if (IsIn(i, x3()))              //    i  -  
						{
							state = 0;
							break;
						}
					}
					break;
				case 10:
					if (IsIn(13, x3()))	                //    13  -  
					{
						state = 11;
						counter += z13().size();
						return z13();
					}

					for (int i = 1; i <= 8; i++)        
					{
						if (IsIn(i, x3()))              //    i  -  
						{
							state = 0;
							break;
						}
					}
					break;
				case 11:
					if (IsIn(13, x3()))	                //    13  -  
					{
						state = 12;
						counter += z13().size();
						return z13();
					}

					for (int i = 1; i <= 8; i++)        
					{
						if (IsIn(i, x3()))              //    i  -  
						{
							state = 0;
							break;
						}
					}
					break;
				case 12:
					for (int i = 9; i <= 12; i++)
					{
						if (IsIn(i, x3()))              //    i  -  
						{
							state = i + 4;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 17;
					break;
				case 13:	case 14:	case 15:	case 16:
					state = 0;
					break;
				case 17:
					state = 0;
					automata = 3;						//   
					break;
				default:
					break;
			}
			break;
		//  4 -  #4
		case 3:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 7; i++)
					{
						if (IsIn(i, x4()))				//    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 8;
					break;
				case 1:		case 2:		case 3:		case 4:		
				case 5:		case 6:		case 7:
					state = 8;
					break;
				case 8:
					state = 0;
					automata = 4;						//   
					break;
				default:
					break;
			}
			break;
		//  5 -  #5
		case 4:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 3; i++)
					{
						if (IsIn(i, x5()))				//    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 4;
					break;
				case 1:		case 2:		case 3:
					state = 4;
					break;
				case 4:
					for (int i = 4; i <= 5; i++)
					{
						if (IsIn(i, x5()))				//    i  -  
						{
							state = i + 1;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 7;
					break;
				case 5:		case 6:
					state = 7;
					break;
				case 7:
					if (IsIn(6, x5())) {				//    6  -  
						state = 8;
						counter += z6().size();
						return z6();
					} else {
						state = 8;
					}
					break;
				case 8:
					state = 0;
					automata = 5; 						//   
					break;
				default:
					break;
			}
			break;
		//  6 -  #6
		case 5:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 3; i++)
					{
						if (IsIn(i, x6()))				//    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 4;
					break;
				case 1:		case 2:		case 3:
					state = 4;
					break;
				case 4:
					for (int i = 4; i <= 5; i++)
					{
						if (IsIn(i, x6()))				//    i  -  
						{
							state = i + 1;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 7;
					break;
				case 5:		case 6:
					state = 7;
					break;
				case 7:
					state = 0;
					automata = 6;						//   
					break;
				default:
					break;
			}
			break;
		//  7 -  #7
		case 6:
			switch (state)
			{
				case 0:
					for (int i = 1; i <= 2; i++)
					{
						if (IsIn(i, x7()))				//    i  -  
						{
							state = i;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 3;
					break;
				case 1:		case 2:		case 3:
					state = 4;
					counter += z3().size();
					return z3();
					break;
				case 4:
					for (int i = 1; i <= 2; i++)
					{
						if (IsIn(i, x7()))				//    i  -  
						{
							state = i + 4;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 7;
					break;
				case 5:		case 6:		case 7:
					state = 8;
					counter += z3().size();
					return z3();
					break;
				case 8:
					for (int i = 1; i <= 2; i++)
					{
						if (IsIn(i, x7()))				//    i  -  
						{
							state = i + 8;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 11;
					break;
				case 9:		case 10:	case 11:
					state = 12;
					counter += z3().size();
					return z3();
					break;
				case 12:
					for (int i = 1; i <= 2; i++)
					{
						if (IsIn(i, x7()))				//    i  -  
						{
							state = i + 12;
							counter += z(i).size();
							return z(i);
						}
					}

					state = 15;
					break;
				case 13:	case 14:	case 15:
					if (IsIn(3, x7())) {				//    3  -  
						state = 18;
					} else {
						state = 16;
						counter += z3().size();
						return z3();
					}
					break;
				case 16:
					if (IsIn(3, x7())) {				//    3  -  
						state = 18;
					} else {
						state = 17;
						counter += z3().size();
						return z3();
					}
					break;
				case 17:
					if (IsIn(3, x7())) {				//    3  -  
						state = 18;
					} else {
						state = 18;
						counter += z3().size();
						return z3();
					}
					break;
				case 18:
					automata = 7;						//  
					finish = true;						//  
					break;
				default:
					break;
			}
		default:
			break;
	}

	return act;
}


//  
list <int> private CAutoBrick::x1()
/*
	    
*/
{
	list <int> st;

	if ( (br->GetColor(2, 2) == 2) && (br->GetColor(6, 8) == 1) )		// I.a.1
		st.push_back(1);

	if ( (br->GetColor(3, 2) == 3) && (br->GetColor(6, 6) == 1) )		// I.a.2
		st.push_back(2);

	if ( (br->GetColor(5, 2) == 5) && (br->GetColor(6, 4) == 1) )		// I.a.3
		st.push_back(3);

	if ( (br->GetColor(4, 2) == 4) && (br->GetColor(6, 2) == 1) )		// I.a.4
		st.push_back(4);

	if ( (br->GetColor(2, 2) == 1) && (br->GetColor(6, 8) == 2) )		// I.b.1
		st.push_back(5);

	if ( (br->GetColor(3, 2) == 1) && (br->GetColor(6, 6) == 3) )		// I.b.2
		st.push_back(6);
	
	if ( (br->GetColor(5, 2) == 1) && (br->GetColor(6, 4) == 5) )		// I.b.3
		st.push_back(7);
	
	if ( (br->GetColor(4, 2) == 1) && (br->GetColor(6, 2) == 4) )		// I.b.4
		st.push_back(8);
	
	if (br->GetColor(2, 6) == 1)										// I.c.1
		st.push_back(9);
	
	if (br->GetColor(3, 6) == 1)										// I.c.2
		st.push_back(10);

	if (br->GetColor(5, 6) == 1)										// I.c.3
		st.push_back(11);
	
	if (br->GetColor(4, 6) == 1)										// I.c.4
		st.push_back(12);

	if (br->GetColor(2, 4) == 1)										// I.d.1
		st.push_back(13);
	
	if (br->GetColor(3, 4) == 1)										// I.d.2
		st.push_back(14);

	if (br->GetColor(5, 4) == 1)										// I.d.3
		st.push_back(15);
	
	if (br->GetColor(4, 4) == 1)										// I.d.4
		st.push_back(16);

	if (br->GetColor(2, 8) == 1)										// I.e.1
		st.push_back(17);
	
	if (br->GetColor(3, 8) == 1)										// I.e.2
		st.push_back(18);

	if (br->GetColor(5, 8) == 1)										// I.e.3
		st.push_back(19);
	
	if (br->GetColor(4, 8) == 1)										// I.e.4
		st.push_back(20);

	if ( (br->GetColor(2, 8) != 2) && (br->GetColor(1, 2) == 1) )		// I.f.1
		st.push_back(21);
	
	if ( (br->GetColor(3, 8) != 3) && (br->GetColor(1, 6) == 1) )		// I.f.2
		st.push_back(22);

	if ( (br->GetColor(5, 8) != 5) && (br->GetColor(1, 4) == 1) )		// I.f.3
		st.push_back(23);
	
	if ( (br->GetColor(4, 8) != 4) && (br->GetColor(1, 8) == 1) )		// I.f.4
		st.push_back(24);
	
	
	if (st.empty())														//     ,  
		st.push_back(25);

	return st;
}

list <int> private CAutoBrick::x2()
/*
	    
*/
{
	list <int> st;

	if ( (br->GetColor(2, 3) == 1) && (br->GetColor(3, 1) == 3) && (br->GetColor(6, 9) == 2) )	// II.a.1
		st.push_back(1);
	
	if ( (br->GetColor(5, 3) == 1) && (br->GetColor(2, 1) == 2) && (br->GetColor(6, 7) == 5) )	// II.a.2
		st.push_back(2);
	
	if ( (br->GetColor(3, 3) == 1) && (br->GetColor(4, 1) == 4) && (br->GetColor(6, 3) == 3) )	// II.a.3
		st.push_back(3);
	
	if ( (br->GetColor(4, 3) == 1) && (br->GetColor(5, 1) == 5) && (br->GetColor(6, 1) == 4) )	// II.a.4
		st.push_back(4);

	if ( (br->GetColor(2, 3) == 2) && (br->GetColor(3, 1) == 1) && (br->GetColor(6, 9) == 3) )	// II.b.1
		st.push_back(5);
	
	if ( (br->GetColor(5, 3) == 5) && (br->GetColor(2, 1) == 1) && (br->GetColor(6, 7) == 2) )	// II.b.2
		st.push_back(6);
	
	if ( (br->GetColor(3, 3) == 3) && (br->GetColor(4, 1) == 1) && (br->GetColor(6, 3) == 4) )	// II.b.3
		st.push_back(7);
	
	if ( (br->GetColor(4, 3) == 4) && (br->GetColor(5, 1) == 1) && (br->GetColor(6, 1) == 5) )	// II.b.4
		st.push_back(8);
	
	if ( (br->GetColor(2, 3) == 3) && (br->GetColor(3, 1) == 2) && (br->GetColor(6, 9) == 1) )	// II.c.1
		st.push_back(9);
	
	if ( (br->GetColor(5, 3) == 2) && (br->GetColor(2, 1) == 5) && (br->GetColor(6, 7) == 1) )	// II.c.2
		st.push_back(10);
	
	if ( (br->GetColor(3, 3) == 4) && (br->GetColor(4, 1) == 3) && (br->GetColor(6, 3) == 1) )	// II.c.3
		st.push_back(11);
	
	if ( (br->GetColor(4, 3) == 5) && (br->GetColor(5, 1) == 4) && (br->GetColor(6, 1) == 1) )	// II.c.4
		st.push_back(12);

	if (br->GetColor(2, 9) == 1)																// II.d.1
		st.push_back(13);
	
	if (br->GetColor(5, 9) == 1)																// II.d.2
		st.push_back(14);

	if (br->GetColor(3, 9) == 1)																// II.d.3
		st.push_back(15);
	
	if (br->GetColor(4, 9) == 1)																// II.d.4
		st.push_back(16);
	
	if (br->GetColor(3, 7) == 1)																// II.e.1
		st.push_back(17);
	
	if (br->GetColor(2, 7) == 1)																// II.e.2
		st.push_back(18);

	if (br->GetColor(4, 7) == 1)																// II.e.3
		st.push_back(19);
	
	if (br->GetColor(5, 7) == 1)																// II.e.4
		st.push_back(20);

	if ( (br->GetColor(1, 1) == 1) && ((br->GetColor(5, 9) != 5) || (br->GetColor(2, 7) != 2)) )// II.f.1
		st.push_back(21);
	
	if ( (br->GetColor(1, 3) == 1) && ((br->GetColor(2, 9) != 2) || (br->GetColor(3, 7) != 3)) )// II.f.2
		st.push_back(22);

	if ( (br->GetColor(1, 9) == 1) && ((br->GetColor(3, 9) != 3) || (br->GetColor(4, 7) != 4)) )// II.f.3
		st.push_back(23);
	
	if ( (br->GetColor(1, 7) == 1) && ((br->GetColor(4, 9) != 4) || (br->GetColor(5, 7) != 5)) )// II.f.4
		st.push_back(24);


	if (st.empty())														//     ,  
		st.push_back(25);

	return st;
}

list <int> private CAutoBrick::x3()
/*
	    
*/
{
	list <int> st;

	if ( (br->GetColor(2, 2) == 2) && (br->GetColor(6, 8) == 5) )		// III.a.1
		st.push_back(1);

	if ( (br->GetColor(3, 2) == 3) && (br->GetColor(6, 6) == 2) )		// III.a.2
		st.push_back(2);

	if ( (br->GetColor(4, 2) == 4) && (br->GetColor(6, 2) == 3) )		// III.a.3
		st.push_back(3);

	if ( (br->GetColor(5, 2) == 5) && (br->GetColor(6, 4) == 4) )		// III.a.4
		st.push_back(4);
	
	if ( (br->GetColor(2, 2) == 2) && (br->GetColor(6, 8) == 3) )		// III.b.1
		st.push_back(5);

	if ( (br->GetColor(5, 2) == 5) && (br->GetColor(6, 4) == 2) )		// III.b.2
		st.push_back(6);

	if ( (br->GetColor(4, 2) == 4) && (br->GetColor(6, 2) == 5) )		// III.b.3
		st.push_back(7);

	if ( (br->GetColor(3, 2) == 3) && (br->GetColor(6, 6) == 4) )		// III.b.4
		st.push_back(8);


	if (st.empty())														//     ,  
		st.push_back(13);


	if ( (br->GetColor(3, 4) != 3) || (br->GetColor(2, 6) != 2) )		// III.c.1
		st.push_back(9);

	if ( (br->GetColor(2, 4) != 2) || (br->GetColor(5, 6) != 5) )		// III.c.2
		st.push_back(10);

	if ( (br->GetColor(5, 4) != 5) || (br->GetColor(4, 6) != 4) )		// III.c.3
		st.push_back(11);

	if ( (br->GetColor(4, 4) != 4) || (br->GetColor(3, 6) != 3) )		// III.c.4
		st.push_back(12);

	return st;
}

list <int> private CAutoBrick::x4()
/*
	    
*/
{
	list <int> st;
	
	if ( (br->GetColor(2, 2) == 6) && (br->GetColor(3, 2) == 6) && 
		 (br->GetColor(6, 2) == 6) && (br->GetColor(6, 4) == 6) )		// IV.a.1
		st.push_back(1);

	if ( (br->GetColor(2, 2) == 6) && (br->GetColor(5, 2) == 6) && 
		 (br->GetColor(6, 2) == 6) && (br->GetColor(6, 6) == 6) )		// IV.a.2
		st.push_back(2);

	if ( (br->GetColor(4, 2) == 6) && (br->GetColor(3, 2) == 6) && 
		 (br->GetColor(6, 4) == 6) && (br->GetColor(6, 8) == 6) )		// IV.a.3
		st.push_back(3);

	if ( (br->GetColor(4, 2) == 6) && (br->GetColor(5, 2) == 6) &&
		 (br->GetColor(6, 6) == 6) && (br->GetColor(6, 8) == 6) )		// IV.a.4
		st.push_back(4);

	if ( (br->GetColor(2, 2) == 6) && (br->GetColor(4, 2) == 6) && 
		 (br->GetColor(6, 4) == 6) && (br->GetColor(6, 6) == 6) )		// IV.b.1
		st.push_back(5);

	if ( (br->GetColor(3, 2) == 6) && (br->GetColor(5, 2) == 6) && 
		 (br->GetColor(6, 2) == 6) && (br->GetColor(6, 8) == 6) )		// IV.b.2
		st.push_back(6);

	if ( (br->GetColor(2, 2) == 6) && (br->GetColor(3, 2) == 6) && 
		 (br->GetColor(4, 2) == 6) && (br->GetColor(5, 2) == 6) )		// IV.c.1
		st.push_back(7);

	return st;
}

list <int> private CAutoBrick::x5()
/*
	    
*/
{
	list <int> st;
	
	if (br->GetColor(3, 2) == 2)										// V.a.1
		st.push_back(1);

	if (br->GetColor(5, 2) == 2)										// V.a.2
		st.push_back(2);

	if (br->GetColor(4, 2) == 2)										// V.a.3
		st.push_back(3);

	if (br->GetColor(4, 2) == 3)										// V.b.1
		st.push_back(4);

	if (br->GetColor(5, 2) == 3)										// V.b.2
		st.push_back(5);

	if (br->GetColor(5, 2) == 4)										// V.c.1
		st.push_back(6);

	return st;
}

list <int> private CAutoBrick::x6()
/*
	    
*/
{
	list <int> st;

	if (IsEqual(br->GetColor(5, 3), br->GetColor(2, 1), br->GetColor(6, 7), 2, 3, 6))				// VI.a.1
		st.push_back(1);

	if (IsEqual(br->GetColor(3, 3), br->GetColor(4, 1), br->GetColor(6, 3), 2, 3, 6))				// VI.a.2
		st.push_back(2);

	if (IsEqual(br->GetColor(4, 3), br->GetColor(5, 1), br->GetColor(6, 1), 2, 3, 6))				// VI.a.3
		st.push_back(3);
	
	if (IsEqual(br->GetColor(5, 3), br->GetColor(2, 1), br->GetColor(6, 7), 3, 4, 6))				// VI.b.1
		st.push_back(4);
	
	if (IsEqual(br->GetColor(4, 3), br->GetColor(5, 1), br->GetColor(6, 1), 3, 4, 6))				// VI.b.2
		st.push_back(5);

	return st;
}

list <int> private CAutoBrick::x7()
/*
	    
*/
{
	list <int> st;

	if (br->GetColor(3, 1) == 6)										// VII.a.1
		st.push_back(1);

	if (br->GetColor(2, 3) == 6)										// VII.a.2
		st.push_back(2);
	
	if ( (br->GetColor(2, 3) == 2) && (br->GetColor(2, 1) == 2) &&		// VII.b.1
		 (br->GetColor(3, 1) == 3) && (br->GetColor(3, 3) == 3) &&
		 (br->GetColor(4, 1) == 4) && (br->GetColor(4, 3) == 4) &&
		 (br->GetColor(5, 1) == 5) && (br->GetColor(5, 3) == 5) )
		 st.push_back(3);

	return st;
}


//   
list <action> private CAutoBrick::z1()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 2, true);
			AddAction(&act, 2, true);
			break;
		case 1:
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			break;
		case 2:
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			break;
		case 3:
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 2, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			break;
		case 5:
			AddAction(&act, 2, false);
			AddAction(&act, 5, false);
			AddAction(&act, 2, true);
			AddAction(&act, 3, false);
			AddAction(&act, 2, false);
			AddAction(&act, 5, true);
			AddAction(&act, 2, true);
			AddAction(&act, 3, true);
			break;
		case 6:
			AddAction(&act, 2, false);
			AddAction(&act, 3, true);
			AddAction(&act, 2, true);
			AddAction(&act, 3, false);
			AddAction(&act, 2, false);
			AddAction(&act, 3, true);
			AddAction(&act, 2, true);
			AddAction(&act, 3, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z2()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 3, true);
			AddAction(&act, 3, true);
			break;
		case 1:
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			break;
		case 2:
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			break;
		case 3:
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 5, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			break;
		case 5:
			AddAction(&act, 3, false);
			AddAction(&act, 2, false);
			AddAction(&act, 5, false);
			AddAction(&act, 2, true);
			AddAction(&act, 3, true);
			AddAction(&act, 2, false);
			AddAction(&act, 5, true);
			AddAction(&act, 2, true);
			break;
		case 6:
			AddAction(&act, 3, true);
			AddAction(&act, 2, false);
			AddAction(&act, 3, false);
			AddAction(&act, 2, true);
			AddAction(&act, 3, true);
			AddAction(&act, 2, false);
			AddAction(&act, 3, false);
			AddAction(&act, 2, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> CAutoBrick::z3()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 5, true);
			AddAction(&act, 5, true);
			break;
		case 1:
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			break;
		case 2:
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			break;
		case 3:
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 3, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);

			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);

			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			break;
		case 5:
			AddAction(&act, 2, false);
			AddAction(&act, 5, false);
			AddAction(&act, 4, false);
			AddAction(&act, 5, true);
			AddAction(&act, 2, true);
			AddAction(&act, 5, false);
			AddAction(&act, 4, true);
			AddAction(&act, 5, true);
			break;
		case 6:
			AddAction(&act, 6, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> CAutoBrick::z4()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 4, true);
			AddAction(&act, 4, true);
			break;
		case 1:
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			break;
		case 2:
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			break;
		case 3:
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 4, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			break;
		case 5:
			AddAction(&act, 4, false);
			AddAction(&act, 3, false);
			AddAction(&act, 4, true);
			AddAction(&act, 5, false);
			AddAction(&act, 4, false);
			AddAction(&act, 3, true);
			AddAction(&act, 4, true);
			AddAction(&act, 5, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> CAutoBrick::z5()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 2, true);
			AddAction(&act, 3, true);
			break;
		case 1:
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			break;
		case 3:
			AddAction(&act, 2, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);

			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);

			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			break;
		case 5:
			AddAction(&act, 5, false);
			AddAction(&act, 4, false);
			AddAction(&act, 3, false);
			AddAction(&act, 4, true);
			AddAction(&act, 5, true);
			AddAction(&act, 4, false);
			AddAction(&act, 3, true);
			AddAction(&act, 4, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> CAutoBrick::z6()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 3, true);
			AddAction(&act, 4, true);
			break;
		case 1:
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			break;
		case 3:
			AddAction(&act, 3, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			break;
		case 4:
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z7()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 5, true);
			AddAction(&act, 2, true);
			break;
		case 1:
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			break;
		case 3:
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 2, false);
			AddAction(&act, 3, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z8()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 4, true);
			AddAction(&act, 5, true);
			break;
		case 1:
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z9()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			break;
		case 1:
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, true);
			AddAction(&act, 3, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z10()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			break;
		case 1:
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, true);
			AddAction(&act, 2, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z11()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			break;
		case 1:
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, true);
			AddAction(&act, 4, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z12()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			break;
		case 1:
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			AddAction(&act, 6, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, true);
			AddAction(&act, 5, false);
			break;
		case 2:
			AddAction(&act, 6, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			AddAction(&act, 6, true);
			AddAction(&act, 3, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z13()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			break;
		case 1:
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			break;
		case 2:
			AddAction(&act, 6, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z14()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			break;
		case 1:
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z15()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			break;
		case 1:
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z16()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			break;
		case 1:
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z17()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 2, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			AddAction(&act, 2, true);
			break;
		case 1:
			AddAction(&act, 2, false);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z18()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 3, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			AddAction(&act, 3, true);
			break;
		case 1:
			AddAction(&act, 5, false);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z19()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 5, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			AddAction(&act, 5, true);
			break;
		case 1:
			AddAction(&act, 3, false);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z20()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 4, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			AddAction(&act, 4, true);
			break;
		case 1:
			AddAction(&act, 4, false);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z21()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 2, true);
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, true);
			AddAction(&act, 2, true);
			break;
		case 1:
			AddAction(&act, 2, true);
			AddAction(&act, 6, false);
			AddAction(&act, 2, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z22()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 3, true);
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, true);
			AddAction(&act, 3, true);
			break;
		case 1:
			AddAction(&act, 3, true);
			AddAction(&act, 6, false);
			AddAction(&act, 3, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z23()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 5, true);
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, true);
			AddAction(&act, 5, true);
			break;
		case 1:
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z24()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 4, true);
			AddAction(&act, 4, true);
			AddAction(&act, 6, false);
			AddAction(&act, 4, true);
			AddAction(&act, 4, true);
			break;
		case 1:
			AddAction(&act, 5, true);
			AddAction(&act, 6, false);
			AddAction(&act, 5, false);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z25()
/*
	    ...  (true)   (false)  
*/
{
	list <action> act;

	switch (automata)
	{
		case 0:
			AddAction(&act, 6, true);
			break;
		case 1:
			AddAction(&act, 6, true);
			break;
		default:
			break;
	}

	return act;
}

list <action> private CAutoBrick::z(int i)
/*
	    ...  (true)   (false)  
*/
{
	switch (i)
	{
		case 1:
			return z1();
		case 2:
			return z2();
		case 3:
			return z3();
		case 4:
			return z4();
		case 5:
			return z5();
		case 6:
			return z6();
		case 7:
			return z7();
		case 8:
			return z8();
		case 9:
			return z9();
		case 10:
			return z10();
		case 11:
			return z11();
		case 12:
			return z12();
		case 13:
			return z13();
		case 14:
			return z14();
		case 15:
			return z15();
		case 16:
			return z16();
		case 17:
			return z17();
		case 18:
			return z18();
		case 19:
			return z19();
		case 20:
			return z20();
		case 21:
			return z21();
		case 22:
			return z22();
		case 23:
			return z23();
		case 24:
			return z24();
		case 25:
			return z25();
	}
}


//  
void CAutoBrick::AddAction(list <action>* act, int side, bool direct)
/*
	     
*/
{
	action rot;
	rot.side   = side;
	rot.direct = direct;

	act->push_back(rot);
}

bool CAutoBrick::IsIn(int i, list <int> st)
/*
	   i   st
*/
{
	for (list <int> :: iterator j = st.begin(); j != st.end(); j++)
	{
		if (*j == i)
		{
			return true;
		}
	}
	
	return false;
}

bool CAutoBrick::IsEqual(int x1, int x2, int x3, int y1, int y2, int y3)
/*
	    
*/
{
	if ( ( (x1 == y1) && (x2 == y2) && (x3 == y3) ) ||
		 ( (x1 == y1) && (x2 == y3) && (x3 == y2) ) ||
		 ( (x1 == y2) && (x2 == y1) && (x3 == y3) ) ||
		 ( (x1 == y2) && (x2 == y3) && (x3 == y1) ) ||
		 ( (x1 == y3) && (x2 == y1) && (x3 == y2) ) ||
		 ( (x1 == y3) && (x2 == y1) && (x3 == y2) ) )
		 return true;

	return false;
}