// BigBrick.h:   CBigBrick
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BIGBRICK_H__D0A02268_1759_4DD7_AE50_8C941C45D1C1__INCLUDED_)
#define AFX_BIGBRICK_H__D0A02268_1759_4DD7_AE50_8C941C45D1C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "SmallBrick.h"
#include "Col.h"

class CBigBrick  
{
public:
	CBigBrick();
	virtual ~CBigBrick();
//  
private:
	CSmallBrick bricks[3][3][3];
	float nSize;
	float nX;
	float nY;
	float nZ;
	float nDelta;


// 
private:
	void Refresh();
	//  
	void RotateXNeg(int side);
	void RotateXPos(int side);
	void RotateYNeg(int side);
	void RotateYPos(int side);	
	void RotateZNeg(int side);
	void RotateZPos(int side);

public:
	void SetX(float x);
	void SetY(float y);
	void SetZ(float z);
	void SetSize(float size);
	void SetDelta(float d);
	float GetX();
	float GetY();
	float GetZ();
	float GetSize();
	float GetDelta();
	void Draw();
	void Init();									//    
	
	
	void Rotate(int side, bool dir);
	int GetColor(int x, int y, int z, int side);	//    side c  (x,y,z)
	int GetColor(int side, int num);				//       num   side
	void SetColor(int x, int y, int z, int side, int col);
};

#endif // !defined(AFX_BIGBRICK_H__D0A02268_1759_4DD7_AE50_8C941C45D1C1__INCLUDED_)