// SmallBrick.h:   CSmallBrick
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SMALLBRICK_H__A7B6E5B4_6A6B_4124_858B_1ACAA43B4500__INCLUDED_)
#define AFX_SMALLBRICK_H__A7B6E5B4_6A6B_4124_858B_1ACAA43B4500__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Col.h"

struct color
{
	float red;
	float green;
	float blue;
};

class CSmallBrick  
{
public:
	CSmallBrick();
	virtual ~CSmallBrick();

//  
private:
	CCol nColor[6];	

	float nSize;
	float nX;		// x - 
	float nY;		// y - 
	float nZ;		// z - 
	float nDelta;
	int x;
	int y;
	int z;	

// 
private:
	//     
	void RotateNeg(int &t, int &r);			//   
	void RotatePos(int &t, int &r); 		//   

public:
	void SetX(int tx);						//  
	void SetY(int ty);
	void SetZ(int tz);				
	void SetSize(float size);				//   
	void SetDelta(float d);				
	void SetColor();						//    
	void SetColor(int side, int color);
	int GetX();								//  
	int GetY();
	int GetZ();					
	float GetSize();						//  
	float GetDelta();				
	void Draw();							//  
	void Refresh();							//   
	int GetColor(int side);					//      side

	// 
	void RotateXPos();						//   x   
	void RotateXNeg();						//   x   
	void RotateYPos();						//   y   
	void RotateYNeg();						//   y   
	void RotateZPos();						//   z   
	void RotateZNeg();						//   z   


};

#endif // !defined(AFX_SMALLBRICK_H__A7B6E5B4_6A6B_4124_858B_1ACAA43B4500__INCLUDED_)